<?php
// Sécurité : ne doit pas être exécuté s'il n'est pas lancé par un script autorisé
if ( !defined('OK') )  exit();

////////////////////////////////////////////////////////////////////////////////
//////////////////////////// Gestion de la session /////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// Fonction de connexion à la base MySQL
function connectsql($ecriture=false)  {
  $mysqli = new mysqli($GLOBALS['serveur'],( $ecriture ) ? $GLOBALS['base'].'-adm' : $GLOBALS['base'], $GLOBALS['mdp'], $GLOBALS['base']);
  $mysqli->set_charset('utf8');
  return $mysqli;
}

// Fonction d'écriture des connexion
// $connexion = 1 pour connexion normale, 2 pour connexion light par cookie,
//              3 pour déconnexion, 4 pour reconnexion light, 5 pour
//              reconnexion normale
function logconnect($connexion,$login)  {
  if ( is_dir('sauvegarde') && is_executable('sauvegarde') && is_writable('sauvegarde') )  {
    $mois = date('Y-m');
    if ( !file_exists("sauvegarde/connexion.$mois.php") )  {
      $fichier = fopen("sauvegarde/connexion.$mois.php",'wb');
      fwrite($fichier, "<?php exit(); ?>\n\n");
    }
    else
      $fichier = fopen("sauvegarde/connexion.$mois.php",'ab');
    switch ( $connexion )  {
      case 1: fwrite($fichier, 'Le '.date('d/m/Y à H:i:s').", connexion de $login\n"); break;
      case 2: fwrite($fichier, 'Le '.date('d/m/Y à H:i:s').", connexion light par cookie de $login\n"); break;
      case 3: fwrite($fichier, 'Le '.date('d/m/Y à H:i:s').", déconnexion de $login\n"); break;
      case 4: fwrite($fichier, 'Le '.date('d/m/Y à H:i:s').", reconnexion light de $login\n"); break;
      case 5: fwrite($fichier, 'Le '.date('d/m/Y à H:i:s').", reconnexion normale de $login\n"); break;
    }
    fclose($fichier);
  }
}

// Fonction de remplissage de la variable $_SESSION
// Le paramètre $light est true si la connexion est obtenue par cookie,
// et ne sert donc qu'à la lecture
// Cette fonction sert dans ajax.php et fonctions.php
function enregistre_session($r,$light=true)  {
  // Interdiction de garder son identifiant de session
  session_regenerate_id(true);
  $_SESSION = array();
  // Interdiction de pouvoir se connecter aux autres site sur le même serveur
  $_SESSION[md5($GLOBALS['site'])] = true;
  // Pour vérification aux connexions ultérieures
  $_SESSION['client'] = $_SERVER['HTTP_USER_AGENT'];
  $_SESSION['ip'] = $_SERVER['REMOTE_ADDR'];
  $_SESSION['login'] = $r['login'];
  $_SESSION['id'] = $r['id'];
  $_SESSION['permconn'] = $r['permconn'];
  $_SESSION['lastconn'] = $r['lastconn'];
  // Mise à jour de dernière connexion
  $mysqli = connectsql(true);
  $mysqli->query("UPDATE utilisateurs SET lastconn = NOW() WHERE id = ${r['id']}");
  // Autorisations
  $_SESSION['light'] = $light;
  $_SESSION['autorisation'] = $r['autorisation'];
  $_SESSION['mailenvoi'] = $r['mailenvoi'];
  $_SESSION['matieres'] = $r['matieres'];
  // Temps de session
  $_SESSION['timeout'] = $r['timeout'];
  $_SESSION['time'] = ( $_SESSION['timeout'] == 0 ) ? time()+900 : time()+$_SESSION['timeout'];
  // Écriture de la connexion dans le fichier de log
  logconnect(1+$light,$r['login']);
  // Pour sécurisation des requêtes AJAX
  $_SESSION['csrf-token'] = ( isset($_REQUEST['csrf-token']) ) ? $_REQUEST['csrf-token'] : bin2hex(random_bytes(32));
}

// Fonction de vérification de la qualité light ou non de la connexion
// Renvoie true si la connexion est complète, false si elle est light.
// Les connexions permanentes le sont par connexion par cookie, sans taper
// son mot de passe systématiquement. Pour les modifications, il faut se
// connecter à nouveau. Cette fonction n'est utilisée que dans ajax.php.
function connexionlight()  {
  if ( $_SESSION['light'] )
    exit('{"etat":"mdp"}');
  return true;
}

// Création de session
session_name(md5($site));
session_set_cookie_params(0,strchr($site,'/').'/',str_replace(strchr($site,'/'),'',$site),true);
session_start();
// Niveau d'autorisation
//  * 0 = non connecté
//  * 1 = compte invité
//  * 2 = élève
//  * 3 = colleur
//  * 4 = administration
//  * 5 = professeur
// Gestion des protections : voir la fonction acces ci-dessous
$message = '';
// Gestion des utilisateurs connectés
if ( isset($_SESSION[md5("$site")]) )  {
  // Passage en connexion light si timeout mais connexion permanente
  if ( ( $_SESSION['time'] < time() ) && !$_SESSION['light'] && $_SESSION['permconn'] )  {
    $_SESSION['light'] = true;
    // Écriture de la connexion dans le fichier de log
    logconnect(4,$_SESSION['login']);
    // Mise à jour du timeout : une session est conservée moins d'un jour sur le serveur
    $_SESSION['timeout'] = 86400;
    $_SESSION['time'] = time()+86400;
  }
  // Passage en connexion normale si reconnexion sur une connexion light
  elseif ( $_SESSION['light'] && isset($_REQUEST['motdepasse']) )  {
    $mysqli = connectsql();
    // Récupération des logins/mdp dans la base MySQL et comparaison
    $resultat = $mysqli->query('SELECT timeout FROM utilisateurs WHERE mdp = \''.sha1($mdp.$_REQUEST['motdepasse']).'\' OR mdp = \''.sha1($_REQUEST['motdepasse'])."' AND id = ${_SESSION['id']}");
    $mysqli->close();
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_row();
      $resultat->free();
      $_SESSION['light'] = false;
      // Écriture de la connexion dans le fichier de log
      logconnect(5,$_SESSION['login']);
      // Mise à jour du timeout
      $_SESSION['timeout'] = $r[0];
      $_SESSION['time'] = ( $_SESSION['timeout'] == 0 ) ? time()+900 : time()+$_SESSION['timeout'];
      // Si paramètre "connexion", reconnexion sans autre demande (par login.php),
      // suivie d'un rechargement immédiat : terminaison et $_SESSION['message']
      if ( isset($_REQUEST['connexion']) )
        exit($_SESSION['message'] = '{"etat":"ok","message":"Connexion réussie"}');
    }
    else
      exit('{"etat":"'.(isset($_REQUEST['connexion'])?'':'mdp').'nok","message":"Mauvais mot de passe"}');
  }
  // Déconnexion automatique
  elseif ( ( $_SESSION['time'] < time() ) || ( $_SESSION['client'] != $_SERVER['HTTP_USER_AGENT'] ) || ( $_SESSION['ip'] != $_SERVER['REMOTE_ADDR'] ) )  {
    // Écriture de la déconnexion dans le fichier de log
    logconnect(3,$_SESSION['login']);
    // Suppression du cookie et des données de session
    $_SESSION = array();
    setcookie(session_name(),'',time()-3600);
    setcookie('loginpermanent','',time()-3600);
    session_regenerate_id(true);
    // Si déconnexion demandée, pas la peine d'aller plus loin (venant de ajax.php)
    //~ if ( isset($_REQUEST['action']) && ( $_REQUEST['action'] == 'deconnexion' ) )
      //~ exit($_SESSION['message'] = '{"etat":"ok","message":"Déconnexion réussie"}');
    $message = 'Vous devez vous connecter à nouveau, suite à une longue durée d\'inactivité.';
    $_SESSION['autorisation'] = 0;
  }
  // Tout est ok : session valide pendant timeout
  else
    $_SESSION['time'] = ( $_SESSION['timeout'] == 0 ) ? time()+900 : time()+$_SESSION['timeout'];
}
else  {
  // Pas de connexion a priori
  $_SESSION['autorisation'] = 0;
  // Connexion complète (login et mdp, script ajax.php demandé)
  if ( isset($_REQUEST['motdepasse']) && isset($_REQUEST['login']) )  {
    $mysqli = connectsql();
    // Récupération des logins/mdp dans la base MySQL et comparaison
    $resultat = $mysqli->query('SELECT id, login, mdp, autorisation, matieres, timeout, mailenvoi, permconn, lastconn FROM utilisateurs WHERE mdp = \''.sha1($mdp.$_REQUEST['motdepasse']).'\' OR mdp = \''.sha1($_REQUEST['motdepasse']).'\'');
    $mysqli->close();
    while ( $r = $resultat->fetch_assoc() )
      if ( $r['login'] == $_REQUEST['login'] )  {
        enregistre_session($r,false);
        // Modification interne du stockage du mot de passe -- mesure temporaire
        if ( $r['mdp'] == sha1($_REQUEST['motdepasse']) )  {
          $mysqli = connectsql(true);
          $mysqli->query('UPDATE utilisateurs SET mdp = \''.sha1($mdp.$_REQUEST['motdepasse'])."' WHERE id = ${r['id']}");
          $mysqli->close();
        }
        // Écriture du cookie pour connexion light
        if ( $_SESSION['permconn'] )
          setcookie('loginpermanent',$r['permconn'],time()+31536000);
        break;
      }
    $resultat->free();
    if ( $_SESSION['autorisation'] == 0 )  {
      if ( filter_var($_REQUEST['login'],FILTER_VALIDATE_EMAIL) )
        exit('{"etat":"nok","message":"Mauvais couple identifiant/mot de passe. L\'identifiant n\'est pas une adresse électronique."}');
      exit('{"etat":"nok","message":"Mauvais couple identifiant/mot de passe"}');
    }
    // Si paramètre "connexion", connexion initiale (bouton "connexion" ou login.php),
    // suivie d'un rechargement immédiat : terminaison et $_SESSION['message']
    if ( isset($_REQUEST['connexion']) )  {
      if ( isset($_REQUEST['permconn']) )  {
        // Token de connexion automatique
        $permconn = '';
        if ( !strlen($permconn) && isset($_REQUEST['permconn']) )
          for ( $i = 0; $i < 10; $i++ )
            $permconn .= '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'[random_int(0,61)];
        $mysqli = connectsql(true);
        $mysqli->query("UPDATE utilisateurs SET permconn = '$permconn' WHERE id = ${r['id']}");
        $mysqli->close();
        $_SESSION['permconn'] = $permconn;
        setcookie('loginpermanent',$permconn,time()+31536000);
      }
      exit($_SESSION['message'] = '{"etat":"ok","message":"Connexion réussie"}');
    }
  }
  // Connexion light automatique par cookie
  elseif ( isset($_COOKIE['loginpermanent']) && preg_match('/^\w{10}$/',$_COOKIE['loginpermanent']) )  {
    $mysqli = connectsql();
    // Récupération des logins/mdp dans la base MySQL et comparaison
    $resultat = $mysqli->query("SELECT id, login, autorisation, matieres, timeout, mailenvoi, permconn, lastconn FROM utilisateurs WHERE mdp > '0' AND permconn = '${_COOKIE['loginpermanent']}'");
    $mysqli->close();
    if ( $resultat->num_rows )  {
      enregistre_session($resultat->fetch_assoc(),true);
      $_SESSION['timeout'] = 86400;
      $_SESSION['time'] = time()+86400;
      $resultat->free();
    }
    // Suppression du cookie s'il ne correspond pas à un compte
    else 
      setcookie('loginpermanent','',time()-3600);
  }
}
$autorisation = $_SESSION['autorisation'];

////////////////////////////////////////////////////////////////////////////////
////////////////////// Mise à jour de la base de données ///////////////////////
////////////////////////////////////////////////////////////////////////////////

// Fonction d'envoi de requêtes MySQL et d'enregistrement
//  * sauvegarde une fois par mois la table complète
//  * enregistre la requête
//  * exécute la requête
//  * renvoie le résultat de l'exécution
function requete($table,$requete,$mysqli)  {
  if ( is_dir($rep = 'sauvegarde') && is_executable('sauvegarde') && is_writable('sauvegarde') )  {
    // Sauvegarde de la table complète une seule fois par mois
    $mois = date('Y-m');
    $heure = date('d/m/Y à H:i:s');
    if ( !file_exists("$rep/$table.$mois.php") )  {
      $s = <<<FIN
  <?php exit(); ?>
-- Sauvegarde complète de la table $table le $heure
TRUNCATE `$table`; 
FIN;
      $resultat = $mysqli->query("SHOW COLUMNS FROM `$table`");
      $s1 = "INSERT INTO $table (";
      while ( $r = $resultat->fetch_row() )
        $s1 .= "`${r[0]}`,";
      $s1 = substr($s1,0,-1).') VALUES';
      $resultat->free();
      // Récupération des données
      $resultat = $mysqli->query("SELECT * FROM `$table`");
      if ( $resultat->num_rows )  {
        while ( $r = $resultat->fetch_row() )
          $s1 .= "\n  ('".  str_replace('SEPARATEUR','\',\'',addslashes(implode('SEPARATEUR',$r)))  .'\'),';
        $s1 = substr($s1,0,-1).';';
        $resultat->free();
      }
      else
        $s1 = '-- Table vide !';
      $fichier = fopen("$rep/$table.$mois.php",'wb');
      fwrite($fichier, "$s\n$s1\n");
    }
    else
      $fichier = fopen("$rep/$table.$mois.php",'ab');
    // Éxécution de la requête
    $resultat = $mysqli->query($requete);
    // Sauvegarde systématique de la requête
    $insert = ( $mysqli->insert_id ) ? ' (identifiant '.$mysqli->insert_id.')' : '';
    if ( isset($_SESSION['login'])  )
      fwrite($fichier, "\n-- Requête de ${_SESSION['login']} (${_SESSION['ip']}) le $heure\n$requete; -- ".$mysqli->affected_rows." ligne(s) affectée(s)$insert\n");
    else  {
      $login = ( isset($GLOBALS['utilisateur']) ) ? $GLOBALS['utilisateur']['login'] : $GLOBALS['login'];
      fwrite($fichier, "\n-- Requête de $login (${_SERVER['REMOTE_ADDR']}) le $heure\n$requete; -- ".$mysqli->affected_rows." ligne(s) affectée(s)$insert\n");
    }
    fclose($fichier);
  }
  return $resultat;
}

// Fonction de mise à jour des informations récentes
function recent($mysqli,$type,$id,$matiere,$prop=array(),$ext='')  {
  // $type : 1->informations, 2->programmes de colles, 3->documents, 5->agenda
  // $id : celui de l'information/le programme de colles/le document/l'événement
  // $matiere : id de la matière concernée (ou 0) pour savoir quel flux modifier
  // $prop : contient titre (sans icône), lien, texte, matiere, protection
  //         incomplet si mise à jour
  //         vide si suppression de l'information récente
  // $ext : ne sert que pour les documents, pour connaître l'icône à mettre

  // Ajout dans la base de données
  if ( count($prop) == 5 )  {
    switch ( $type )  {
      case 1: $icone = '<span class="icon-infos"></span>'; break;
      case 2: $icone = '<span class="icon-colles"></span>'; break;
      case 3:
        // Liste des icônes pour affichage
        $icones = array(
          '.pdf' => 'pdf',
          '.doc' => 'doc', '.odt' => 'doc', '.docx' => 'doc',
          '.xls' => 'xls', '.ods' => 'xls', '.xlsx' => 'xls',
          '.ppt' => 'ppt', '.odp' => 'ppt', '.pptx' => 'ppt',
          '.jpg' => 'jpg', '.jpeg' => 'jpg', '.png' => 'jpg', '.gif' => 'jpg', '.svg' => 'jpg', '.tif' => 'jpg', '.tiff' => 'jpg', '.bmp' => 'jpg', '.ps' => 'jpg', '.eps' => 'jpg',
          '.mp3' => 'mp3', '.ogg' => 'mp3', '.oga' => 'mp3', '.wma' => 'mp3', '.wav' => 'mp3', '.ra' => 'mp3', '.rm' => 'mp3',
          '.mp4' => 'mp4', '.avi' => 'mp4', '.mpeg' => 'mp4', '.mpg' => 'mp4', '.wmv' => 'mp4', '.mp4' => 'mp4', '.ogv' => 'mp4', '.qt' => 'mp4', '.mov' => 'mp4', '.mkv' => 'mp4', '.flv' => 'mp4',
          '.zip' => 'zip', '.rar' => 'zip', '.7z' => 'zip',
          '.py' => 'pyt', '.exe' => 'pyt', '.sh' => 'pyt', '.ml' => 'pyt', '.mw' => 'pyt',
          '.txt' => 'txt', '.rtf' => 'txt', '' => 'txt'
        );
        $icone = '<span class="icon-doc-'.(( isset($icones[strtolower($ext)]) ) ? $icones[strtolower($ext)] : 'txt').'"></span>'; break;
      case 5:
        $icone = '<span class="icon-agenda"></span>';
        // Suppression avant insertion, pour une mise à jour
        requete('recents','DELETE FROM recents WHERE id = '.($type*1000+$id),$mysqli);
    }
    requete('recents',"INSERT INTO recents SET id=".($type*1000+$id).", heure = NOW(), titre = '$icone ${prop['titre']}', lien = '${prop['lien']}', texte = '${prop['texte']}', matiere = '${prop['matiere']}', protection = '${prop['protection']}'",$mysqli);
  }
  // Suppression de la base
  elseif ( empty($prop) )  {
    requete('recents','DELETE FROM recents WHERE id = '.($type*1000+$id),$mysqli);
  }
  // Modification
  else  {
    switch ( $type )  {
      case 1:
        // Modification du titre : pas de changement de date de l'info récente
        if ( isset($prop['titre']) )
          $requete = "titre = '<span class=\"icon-infos\"></span> ${prop['titre']}'";
        // Modification de texte : mise en valeur dans les flux RSS
        elseif ( isset($prop['texte']) )
          $requete = "heure = NOW(), texte = '${prop['texte']}', titre = CONCAT(REPLACE(titre,' (mise à jour)',''),' (mise à jour)')";
        // Modification de la protection : pas de changement de date de l'info récente
        elseif ( isset($prop['protection']) )
          $requete = "protection = ${prop['protection']}";
      break;
      case 2:
        // Modification de texte uniquement
        $requete = "heure = NOW(), texte = '${prop['texte']}', titre = CONCAT(REPLACE(titre,' (mise à jour)',''),' (mise à jour)')";
      break;
      break;
      case 3:
        // Nouveau nom de document : mise à jour du titre et du texte seulement
        if ( isset($prop['nom']) )
          $requete = "titre = REPLACE(REPLACE(CONCAT(titre,'¤'),'/${prop['ancien_nom']}¤','/${prop['nom']}¤'),'¤',''), texte = REPLACE(texte,'/${prop['ancien_nom']}</a>','/${prop['nom']}</a>')";
        // Déplacement de répertoire : mise à jour du chemin et peut-être de la
        // matière. Pas de mise en valeur dans les flux RSS
        elseif ( isset($prop['chemin']) )
          $requete = "texte = REPLACE(texte,SUBSTRING(titre,36),'${prop['chemin']}'), titre = CONCAT(SUBSTRING(titre,1,35),'${prop['chemin']}'), matiere = '${prop['matiere']}'";
        elseif ( isset($prop['maj']) )
          $requete = 'heure = NOW(), texte = REPLACE(texte,\'<p>Nouveau \',\'<p>Mise à jour du \')';
        // Modification de la protection : pas de changement de date de l'info récente
        elseif ( isset($prop['protection']) )
          $requete = "protection = ${prop['protection']}";
      break;
    }
    requete('recents',"UPDATE recents SET $requete WHERE id=".($type*1000+$id),$mysqli);
  }
  
  // Pas la peine d'aller plus loin si la table n'a pas été modifiée.
  if ( !($mysqli->affected_rows) )  {
    // Cas de la mise à jour de document sans info récente liée : on en crée une
    if ( ( $type == 3 ) && isset($prop['maj']) )
      recent($mysqli,3,$id,$matiere,array('titre'=>$prop['maj'], 'lien'=>"download?id=$id", 'texte'=>"<p>Mise à jour du document&nbsp;: <a href=\"download?id=$id\">${prop['maj']}</a></p>", 'matiere'=>$matiere, 'protection'=>$prop['p']),$prop['e']);
    return;
  }

  // Mise dans l'ordre, les plus récents en premier
  $mysqli->query('ALTER TABLE recents ORDER BY heure DESC');
  // Regénération des flux
  $matieres = array(0);
  if ( $matiere )
    $matieres[] = $matiere;
  // Cas des documents déplacés : deux flux à regénérer
  if ( isset($prop['matiere']) && ( $matiere != $prop['matiere'] ) )
    $matieres[] = $prop['matiere'];
  rss($mysqli,$matieres);
}

// Fonction de mise à jour des flux RSS
// $matieres doit être soit zéro ou un identifiant de matière
function rss($mysqli,$matieres)  {
  $requete = '';
  foreach ( $matieres as $matiere ) 
    $requete .= " OR FIND_IN_SET($matiere,matieres)";
  // Récupération de toutes les combinaisons autorisation-matières possibles
  $combinaisons = array('0|toutes');
  $resultat = $mysqli->query('SELECT CONCAT(autorisation,\'|\',matieres) FROM utilisateurs WHERE '.substr($requete,4));
  while ( $r = $resultat->fetch_row() )
    $combinaisons[] = $r[0];
  $resultat->free();
  $combinaisons = array_unique($combinaisons);

  // Préambule du flux RSS - Titre du flux : titre du site
  $resultat = $mysqli->query('SELECT titre FROM pages WHERE id = 1');
  $r = $resultat->fetch_row();
  $resultat->free();
  $titre = $r[0];
  $d = date(DATE_RSS);
  $site = "https://${GLOBALS['site']}";
  $preambule = <<<FIN
<?xml version="1.0" encoding="UTF-8"?>
<rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom">
  <channel>
    <title>$titre</title>
    <atom:link href="$site/REP/rss.xml" rel="self" type="application/rss+xml" />
    <link>$site</link>
    <description>$titre - Flux RSS</description>
    <lastBuildDate>$d</lastBuildDate>
    <language>fr-FR</language>


FIN;

  // Log
  $mois = date('Y-m');
  $heure = date('d/m/Y à H:i:s');
  if ( file_exists("documents/rss/log.$mois.php") )
    $fichierlog = fopen("documents/rss/log.$mois.php",'ab');
  else  {
    if ( !is_dir('documents/rss') )
      mkdir('documents/rss',0777);
    $fichierlog = fopen("documents/rss/log.$mois.php",'wb');
    fwrite($fichierlog,'<?php exit(); ?>');
  }
  fwrite($fichierlog, "\n-- Génération le $heure -- ".json_encode($matieres)."\n");

  // Génération pour les différentes combinaisons autorisation-matières
  foreach ( $combinaisons as $c )  {
    list($autorisation,$matieres) = explode('|',$c);
    $requete = ( $autorisation ) ? "FIND_IN_SET(matiere,'$matieres') AND (".requete_protection($autorisation).')' : 'protection = 0';
    $resultat = $mysqli->query("SELECT UNIX_TIMESTAMP(heure) AS heure, titre, lien, texte, protection FROM recents
                                WHERE $requete AND DATEDIFF(NOW(),heure) < 60");
    $rss = '';
    if ( $resultat->num_rows )  {
      while ( $r = $resultat->fetch_assoc() )  {
        $d = date(DATE_RSS,$r['heure']);
        $titre = preg_replace('/^<.*span> /','',$r['titre']);
        $texte = preg_replace('/href="([^h])/',"href=\"$site/\\1",$r['texte']);
        $rss .= <<<FIN
    <item>
      <title><![CDATA[$titre]]></title>
      <link>$site/${r['lien']}</link>
      <guid isPermaLink="false">${r['heure']}</guid>
      <description><![CDATA[$texte]]></description>
      <pubDate>$d</pubDate>
    </item>


FIN;
      }
      $resultat->free();
    }

    // Mise à jour du flux RSS
    $rep = 'documents/rss/'.sha1("?!${GLOBALS['base']}$c");
    if ( !is_dir($rep) )
      mkdir($rep,0777,true);
    $fichier = fopen($rep.'/rss.xml','wb');
    fwrite($fichier, str_replace('REP',$rep,$preambule).$rss."  </channel>\n</rss>\n");
    fclose($fichier);

    // Log
    fwrite($fichierlog, "  $c $rep\n");
  }
  fclose($fichierlog);
}

// Fonction PHP pour le stockage dans la base MySQL de l'ordre "naturel" (1,2,10,11 et non 1,10,11,2)
// Remplace tout nombre par un nombre égal mais écrit sur 10 chiffres, complété par des zéros à gauche
// Utilisé pour les documents et les groupes
function zpad($s) {
  return preg_replace_callback('/(\d+)/', function($m){
    return(str_pad($m[1],10,'0',STR_PAD_LEFT)); }
  , $s);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////// Gestion des autorisations ///////////////////////////
////////////////////////////////////////////////////////////////////////////////

// Fonction d'accès en lecture ou en écriture
// Retourne true si accès en mode édition (professeur de la matière)
// Retourne faux si accès en mode lecture uniquement (autre utilisateur autorisé)
// Affiche une page de connexion si besoin (et arrête l'exécution)
// Affiche une page d'interdiction et arrête l'exécution sinon
// $protection est une valeur numérique.
// * si $protection = 0, accès autorisé sans connexion identifiée.
// * si 0 < $protection < 33, $protection est la représentation décimale de la
// valeur binaire PACEI (types d'utilisateurs : professeurs, administration,
// colleurs, élèves, invités) à laquelle on a ajouté 1.
// Chaque 0 correspond aux accès autorisés, chaque 1 correspond aux protections
// (accès interdit pour ce type de compte).
// Exemple : 10 -> PACEI=9=01001 -> autorisé pour P,C,E et interdit pour A et I.
// Le code 32 (interdit pour tous) correspond aux docs/reps/... non visibles.
// * si $protection = 32, page non affichée dans le menu, non visible sauf pour
// les professeurs associés à la matière
// $matiere est la matière associée à la page à afficher
// $titre est le titre de la page affichée si accès refusé ou connexion demandée
// $actuel est le lien du menu si accès refusé ou connexion demandée
function acces($protection,$matiere,$titre,$actuel,$mysqli)  {
  $autorisation = $_SESSION['autorisation'];
  // Mode édition
  if ( ( $autorisation == 5 ) && in_array($matiere,explode(',',$_SESSION['matieres'])) )
    return !isset($_REQUEST['mode_lecture']);
  if ( $protection == 0 )
    return false; // accès autorisé sans condition
  // Si page protégée et utilisateur non connecté : connexion demandée
  // login.php contient $mysqli->close() et fin()
  if ( $autorisation == 0 )
    include('login.php');
  // À partir d'ici, on a un utilisateur connecté
  // On affiche seulement si :
  // * pour les professeurs, tout contenu autorisé d'une autre matière
  // * pour les autres, uniquement les contenus à la fois autorisés et de
  // matière associée
  if ( ( $autorisation == 5 ) && ( $protection < 17 ) || in_array($matiere,explode(',',$_SESSION['matieres'])) && ( ( ($protection-1)>>($autorisation-1) & 1 ) == 0 ) )
    return false;
  // Accès non autorisé
  debut($mysqli,$titre,'Vous n\'avez pas accès à cette page.',$autorisation,$actuel);
  $mysqli->close();
  fin();
}
// Version simplifiée pour le test d'éléments seuls, matière déjà vérifiée
// Retourne true si accès autorisé, false si non
function accestest($protection,$autorisation)  {
  if ( ( $protection == 0 ) || ( $autorisation == 5 ) )  return true;
  if ( $autorisation == 0 )  return false;
  if ( ( ($protection-1)>>($autorisation-1) & 1 ) == 0 )  return true;
  return false;
}
// Définition de la chaîne de protection mysql pour récupérer les éléments,
// matière déjà vérifiée, sans mode édition. 
// Pour index.php, agenda.php, cdt.php, docs.php
function requete_protection($autorisation)  {
  return $autorisation ? "( protection = 0 ) OR ( ( (protection-1)>>($autorisation-1) & 1 ) = 0 )" : 'protection = 0';
}

////////////////////////////////////////////////////////////////////////////////
//////////////////////////////// Affichage HTML ////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// En-têtes HTML et début de page
function debut($mysqli,$titre,$message,$autorisation,$actuel=false,$matiere=false,$css=false)  {
  // Menu seulement si $actuel non vide
  if ( $actuel )  {
    
    // Requête partielles de récupération
    // Non connecté : on voit tout ce qui est non vide et non désactivé
    // Invité/Élèves/Colleurs/Administration : on voit ce qui est non vide et
    // autorisé (matière associée et protection correcte)
    // Prof : on voit tout ce qui est non vide et autorisé pour les matières non
    // associées, toutes les pages et reps pour les matières associées, tout ce
    // qui n'est pas désactivé (colles,cdt,docs) pour les matières associées
    switch ( $autorisation )  {
      case 5:
        $requete_matieres = '';
        $requete_pages = "protection < 17 OR FIND_IN_SET(mat,'${_SESSION['matieres']}')";
        $requete_reps = "protection < 17 OR FIND_IN_SET(matiere,'${_SESSION['matieres']}')";
        $requete_collesdocscdt = "X_protection < 17 OR X_protection < 32 AND FIND_IN_SET(m.id,'${_SESSION['matieres']}')";
        $requete_notes = "notes < 2 AND FIND_IN_SET(m.id,'${_SESSION['matieres']}')";
        $requete_rss = "protection < 17 OR FIND_IN_SET(matiere,'${_SESSION['matieres']}')";
        break;
      case 0:
        $requete_matieres = '';
        $requete_pages = $requete_reps = "protection < 32";
        $requete_collesdocscdt = "X_protection < 32";
        $requete_notes = '0';
        $requete_rss = 'protection = 0';
        break;
      default:
        $requete_matieres = "WHERE FIND_IN_SET(m.id,'${_SESSION['matieres']}')";
        $requete_pages = $requete_reps = "protection = 0 OR ( (protection-1)>>($autorisation-1) & 1 ) = 0";
        $requete_collesdocscdt = "( X_protection = 0 OR ( (X_protection-1)>>($autorisation-1) & 1 ) = 0 )";
        $requete_notes = ( ( $autorisation == 3 ) ? "notes < 2 AND FIND_IN_SET(m.id,'${_SESSION['matieres']}')" : 'notes = 1');
        $requete_rss = "FIND_IN_SET(matiere,'${_SESSION['matieres']}') AND ( protection = 0 OR ( (protection-1)>>($autorisation-1) & 1 ) = 0 )";
    }
    
    // Récupération et affichage des pages
    $menu = "<a class=\"icon-menu\" title=\"Afficher le menu\"></a>\n<div id=\"colonne\">\n  <nav>\n";
    $resultat = $mysqli->query("SELECT cle, nom FROM pages WHERE mat = 0 AND (id = 1 OR $requete_pages) ORDER BY ordre");
    $r = $resultat->fetch_assoc();
    // Icônes principales (accueil, agenda, impression, rss)
    $menu .= <<<FIN
    <a class="icon-accueil" href=".?${r['cle']}" title="${r['nom']}"></a>
    <a class="icon-agenda" href="agenda" title="Agenda"></a>
    <a class="icon-imprime" title="Imprimer cette page" onclick="window.print();return false;"></a>
    <a class="icon-rss" href="rss" title="Voir les flux RSS disponibles"></a>

FIN;
    // Préférences (tous types de comptes sauf invité)
    if ( $autorisation > 1 )
      $menu .= "    <a class=\"icon-prefs\" href=\"prefs\" title=\"Gérer ses préférences\"></a>\n";
    // Envoi de courriel
    if ( ( $autorisation > 1 ) && $_SESSION['mailenvoi'] )
      $menu .= "    <a class=\"icon-mail\" href=\"mail\" title=\"Envoyer un courriel\"></a>\n";
    // Connexion/Déconnexion
    $menu .= $autorisation ? "    <a class=\"icon-deconnexion\" title=\"Se déconnecter\"></a>\n    <hr>\n" : "    <a class=\"icon-connexion\" title=\"Se connecter\"></a>\n    <hr>\n";
    // Relève des colles, compte administratif uniquement
    if ( $autorisation == 4 )
      $menu .= "    <a href=\"relevenotes\">Relève des notes</a>\n";
    // Autres pages
    while ( $r = $resultat->fetch_assoc() )
      $menu .= "    <a href=\".?${r['cle']}\">${r['nom']}</a>\n";
    $resultat->free();
    // Page de téléchargement
    $menu .= "    <a href=\"docs\">Documents à télécharger</a>\n";
    $resultat = $mysqli->query("SELECT id, nom FROM reps WHERE matiere = 0 AND menu = 1 AND ( $requete_reps )");
    if ( $resultat->num_rows )  {
      while ( $r = $resultat->fetch_assoc() )
        $menu .= "      <a class=\"menurep\" href=\"docs?rep=${r['id']}\">${r['nom']}</a>\n";
      $resultat->free();
    }
    // Récupération et affichage des matières
    $resultat = $mysqli->query('SELECT * FROM (
                                  SELECT m.id, m.cle, m.nom,
                                  ( colles = 1 AND '.str_replace('X','colles',$requete_collesdocscdt).' ) AS colles,
                                  (   docs = 1 AND '.str_replace('X',  'docs',$requete_collesdocscdt).' ) AS docs,
                                  (    cdt = 1 AND '.str_replace('X',   'cdt',$requete_collesdocscdt).' ) AS cdt,
                                  ( '.$requete_notes.' ) AS notes,
                                  GROUP_CONCAT(CONCAT(m.cle,"/",p.cle) SEPARATOR "//") AS pcle, GROUP_CONCAT(p.nom SEPARATOR "//") AS pnom
                                  FROM matieres AS m LEFT JOIN (
                                    SELECT * FROM pages WHERE '.$requete_pages.'
                                  ) AS p ON p.mat = m.id
                                  '.$requete_matieres.'
                                  GROUP BY m.id ORDER BY m.ordre, p.ordre
                                ) AS t WHERE colles + docs + cdt + notes > 0 OR pnom IS NOT NULL');
    if ( $resultat->num_rows )  {
      while ( $r = $resultat->fetch_assoc() )  {
        $edition = ( $autorisation == 5 ) && ( in_array($r['id'],explode(',',$_SESSION['matieres'])) );
        $menu .= "    <h3>${r['nom']}</h3>\n";
        if ( !is_null($r['pcle']) )  {
          $pcle = explode('//',$r['pcle']);
          $pnom = explode('//',$r['pnom']);
          $nom = $pnom[0];
          foreach ( $pcle as $cle )  {
            $menu .= "    <a href=\".?$cle\">$nom</a>\n";
            $nom = next($pnom);
          }
        }
        if ( $r['colles'] )
          $menu .= "    <a href=\"colles?${r['cle']}\">Programme de colles</a>\n";
        if ( $r['docs'] )  {
          $menu .= "    <a href=\"docs?${r['cle']}\">Documents à télécharger</a>\n";
          $resultat_doc = $mysqli->query("SELECT id, nom FROM reps WHERE matiere = ${r['id']} AND menu = 1 AND ( $requete_reps )");
          if ( $resultat_doc->num_rows )  {
            while ( $d = $resultat_doc->fetch_assoc() )
              $menu .= "    <a class=\"menurep\" href=\"docs?rep=${d['id']}\">${d['nom']}</a>\n";        
            $resultat_doc->free();
          }
        }
        if ( $r['cdt'] )  {
          $menu .= "    <a href=\"cdt?${r['cle']}\">Cahier de texte</a>\n";
          if ( $edition && ( substr($actuel,0,3) == 'cdt' ) && ( substr($actuel,-strlen($r['cle'])-1) == "?${r['cle']}" ) )
            $menu .= "      <a class=\"menurep\" href=\"cdt-seances?${r['cle']}\">Types de séances</a>\n      <a class=\"menurep\" href=\"cdt-raccourcis?${r['cle']}\">Raccourcis de séances</a>\n";
        }
        if ( $r['notes'] )
          $menu .= "    <a href=\"notes?${r['cle']}\">Notes</a>\n";
      }
      $resultat->free();
    }
    // Liens d'édition, professeurs seulement
    if ( $autorisation == 5 )
      $menu .= <<<FIN
    <h3>Gestion du site</h3>
    <a href="pages">Les pages</a>
    <a href="matieres">Les matières</a>
    <a href="utilisateurs">Les utilisateurs</a>
    <a href="utilisateurs-matieres">Les associations utilisateurs-matières</a>
    <a href="groupes">Les groupes</a>
    <a href="planning">Le planning annuel</a>

FIN;
    $menu = str_replace("a href=\"$actuel\"","a id=\"actuel\" href=\"$actuel\"",$menu);
    $menu .= '  </nav>';

    // Affichage des informations récentes
    $recent = '';
    $resultat = $mysqli->query("SELECT titre, lien FROM recents WHERE DATEDIFF(NOW(),heure) < 15 AND $requete_rss LIMIT 20");
    if ( $resultat->num_rows )  {
      $menu = "<a class=\"icon-recent\" title=\"Afficher les informations récentes\"></a>\n$menu";
      while ( $r = $resultat->fetch_assoc() )
        $recent .= "\n    <a href=\"${r['lien']}\" title=\"".substr($r['titre'],strpos($r['titre'],'/span>')+7)."\">${r['titre']}</a>";
      $resultat->free();
      $recent = <<<FIN
  <div id="recent">
    <h3>Infos récentes</h3>$recent
  </div>

FIN;
    }
  }
  else
    $menu = $recent = '';
  if ( strlen($menu.$recent) )
    $recent .= '</div>';
    
  // RSS
  $rss = ( $autorisation ) ? sha1("?!${GLOBALS['base']}$autorisation|${_SESSION['matieres']}") : sha1("?!${GLOBALS['base']}0|toutes");
  // Message si non vide
  if ( strlen($message) )
    $message = "  <div class=\"warning\">$message</div>\n";
  elseif ( ( $autorisation == 5 ) && ( basename($_SERVER['PHP_SELF']) == 'index.php' ) )  {
    $resultat = $mysqli->query('SELECT id FROM utilisateurs WHERE mdp LIKE "*%"');
    if ( $n = $resultat->num_rows )  {
      $resultat->free();
      $n = ( $n > 1 ) ? "$n comptes" : "1 compte";
      $message = '  <div class="warning">Il y a actuellement '.(( $n > 1 ) ? "$n comptes" : "1 compte").' en attente de validation de votre part. C\'est assez urgent... Il faut aller sur la page de gestion des <a href="utilisateurs">utilisateurs</a> pour les valider.</div>';
    }
  }
  // Token CSRF
  $token = ( isset($_SESSION['csrf-token']) ) ? " data-csrf-token=\"${_SESSION['csrf-token']}\"" : '';
  // Matière
  $matiere = ( $matiere ) ? " data-matiere=\"$matiere\"" : '';
  // Titre dans le head : <span> pouvant indiquer la protection en mode édition
  $head = strtok($titre,'<');
  // Fichiers CSS supplémentaires
  $css = ( $css ) ? "\n  <link rel=\"stylesheet\" href=\"css/$css.min.css\">" : '';
  // Affichage
  echo <<<FIN
<!doctype html>
<html lang="fr">
<head>
  <title>$head</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, height=device-height, initial-scale=1.0">
  <link rel="stylesheet" href="css/style1810.min.css">
  <link rel="stylesheet" href="css/icones1810.min.css">$css
  <script type="text/javascript" src="js/jquery.min.js"></script>
  <link rel="alternate" type="application/rss+xml" title="Flux RSS" href="documents/rss/$rss/rss.xml">
</head>
<body$token$matiere>

<header><h1>$titre</h1></header>

$menu
$recent

<section>
$message
FIN;
}

// Bas de page
function fin($edition = false, $mathjax = false)  {
  // MathJax chargé seulement si besoin
  $mathjax = ( $mathjax ) ? '
<script type="text/javascript" src="/MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
<script type="text/x-mathjax-config">MathJax.Hub.Config({tex2jax:{inlineMath:[["$","$"],["\\\\(","\\\\)"]]}});</script>' : '';
  // Édition possible si $edition est true
  $js = ( $edition ) ? '<script type="text/javascript" src="js/edition.min18.js"></script>' : '<script type="text/javascript" src="js/fonctions.min18.js"></script>';
  // Affichage de message si $_SESSION['message']
  if ( isset($_SESSION['message']) )  {
    $m = json_decode($_SESSION['message'],true);
    $m = "\n<script type=\"text/javascript\">$( function() { affiche(\"${m['message']}\",'${m['etat']}'); });</script>";
    unset($_SESSION['message']);
  }
  else
    $m = '';
  echo <<<FIN

</section>

<footer>Ce site est réalisé par le logiciel <a href="http://cahier-de-prepa.fr">Cahier de prépa</a>, publié sous <a href="Licence_CeCILL_V2-fr.html">licence libre</a>.
</footer>
<div id="load"><img src="js/ajax-loader.gif"></div>

$js$mathjax$m

</body>
</html>
FIN;
  exit();
}

// Affichage des semaines
function format_date($date)  {
  $semaine = array('dimanche','lundi','mardi','mercredi','jeudi','vendredi','samedi');
  $mois = array('','janvier','février','mars','avril','mai','juin','juillet','août','septembre','octobre','novembre','décembre');
  return $semaine[substr($date,0,1)].' '.substr($date,7).( ( substr($date,7) == '1' ) ? 'er' : '' ).' '.$mois[intval(substr($date,5,2))].' '.substr($date,1,4);
}

?>
